;; $Header: /home/cvs/src/asm/mbrkill/bootstealth.asm,v 1.20 2018/02/24 15:31:31 ralph Exp $
;; ------------------------------------------------------------------------
;; BOTSTLTH.ASM
;; ------------------------------------------------------------------------
;; Description:      BootStealth - Various tricks with the CMOS to achieve
;;                   Hardware bootstealth capacty! In this version: only
;;                   testing for such tricks!
;; ------------------------------------------------------------------------
;; Compiler:         MicroSoft Macro Assembler (MASM) 6.00 + Macros
;; Date:             Dec 27 1994
;; Project:          Diplomarbeit
;;
;; Updates:          21.02.95   ROM entry point find first/find next
;;                   18.04.95   Finished for "Diplomarbeit"
;;
;; ------------------------------------------------------------------------
;; This is a lesson how to write in a high level assembly (MASM 6.xx) language!
;; ------------------------------------------------------------------------
;; $Log: bootstealth.asm,v $
;; Revision 1.20  2018/02/24 15:31:31  ralph
;; HackStop 1.27
;;
;; Revision 1.19  2018/02/23 20:02:52  ralph
;; MBR enhancements stuff
;; git enhancements
;;
;; Revision 1.18  2017/01/02 09:13:53  ralph
;; Revision 1.17  2015/12/27 12:36:28  ralph
;; Revision 1.16  2014/12/21 14:02:48  ralph
;; Revision 1.15  2014/01/01 21:56:18  ralph
;; Revision 1.14  2012-12-28 12:40:57  ralph
;; Revision 1.13  2012-01-30 21:16:10  Ralph
;; Revision 1.12  2010-12-31 09:55:30  Ralph
;; Revision 1.11  2010/01/13 22:34:57  Ralph
;; added new files, changes copyright to 2010
;; Revision 1.10  2008/12/31 05:25:32  Ralph
;; Revision 1.9  2008/01/06 11:41:50  Ralph
;; Revision 1.8  2005/12/22 06:36:14  ralproth
;; Revision 1.7  2005/01/17 18:17:55  ralproth
;; y2k5 and fixes for batch files
;; Revision 1.6  2004/01/27 08:06:25  ralproth
;; Ripped partition infos added, y2k4
;; Revision 1.5  2003/12/23 21:44:26  ralproth
;; Revision 1.4  2003/01/29 17:37:15  ralph
;; Revision 1.3  2002/04/14 11:52:20  ralph
;; Y2K2, OEM2ASCII
;; Spelling Fixed
;; Revision 1.2  2001/11/04 18:54:38  ralph
;; Added CVS keywords
;;

;; ************************************************************************
;;
;; (C)opyright by
;;
;; ROSE, Ralph Roth
;; Finkenweg 24
;; D 78658 Zimmern o.R.
;; FAX 0741 3 23 28
;;
;; Jedliche kommerzielle Verwendung untersagt. All Right Reserved!
;;
;; ************************************************************************


IFDEF   EXE
        .MODEL  SMALL,  C, OS_DOS
ELSE
        .MODEL  TINY,   C, OS_DOS
ENDIF

.XLIST                                  ;; no macros in output list
.386
include rose.inc
include utils.inc

DisplayDec      proto   Value: WORD;
;; ------------------------------------------------------------------------
        .DOSSEG                         ;; DOS Segmentation
        .DATA                           ;; MASM Symbol for DATA-Segment
;; ---- Datas -------------------------------------------------------------
intro   byte    13, 10
        byte    "BootStealth: Checks the CMOS/BIOS for virus specific manipulation!", 13, 10
        byte    "", 13, 10
        byte    "(c) 1994-2018 by ROSE SWE, Dipl.-Ing. Ralph Roth, RalphRoth@gmx.de", 13, 10
        byte    13, 10, "$"
        byte    "$Header: /home/cvs/src/asm/mbrkill/bootstealth.asm,v 1.20 2018/02/24 15:31:31 ralph Exp $",13,10
MemCMOS word    0
MemBIOS word    0
RomNameMask     byte    "*.*", 0
OurDta  byte    128     dup (0)
;; ---- Code --------------------------------------------------------------


.CODE                                   ;; MASM Symbol for CODE Segment

        ORG     0100h

        .STARTUP                        ;; program start + init

        @ShowStr intro                  ;; Oh, great ROSE again?

        @ShowStr "Diskfloppy installed (needs plain DOS): "
        @ReadPort 14h                   ;; Floppydisk installed?
        mov     bl, al                  ;; save for later, hacker backup to BL
        and     al, 1
        .IF     AL == 1
        and     bl, 11000000y           ;; mask out
        shr     bl, 6                   ;; 0-3
        add     bl, "1"                 ;; convert to ascii
        @ShowChar bl
        @ShowStr " drive(s)."
        .ELSE                           ;; only if diskless or virus!
        @ShowStr "No!"
        @CRLF
        @ShowStr ">>> This could indicated the presence of Windows, the AntiCMOS virus or DosBox!"
        .ENDIF

        @CRLF
        @ReadPort 16h                   ;; get conventionel memory from CMOS
        mov     ah, al                  ;; high
        @ReadPort 15h                   ;; low
        mov     MemCMOS, AX             ;; save if for later
        int     12h                     ;; get conventionel memory from 0:413h
        mov     MemBIOS, AX

        @ShowStr "Base Memory reported by the BIOS is: "
        invoke  DisplayDec, MemBIOS
        @ShowChar "K", "B", 13, 10
        @ShowStr "Base Memory reported by the CMOS is: "
        invoke  DisplayDec, MemCMOS
        @ShowChar "K", "B", 13, 10

        mov     ax, MemCMOS
        mov     bx, MemBIOS             ;; reload
        and     bx, 000Fh               ;; should be zero

        .IF     (AX != MemCMOS) || (BX != 0)
        @ShowStr "Memory size differs, probably a virus is active!?"
        .ELSE
        @ShowStr "Memory size is OK!"
        .ENDIF

        @CRLF
        @ShowStr "Bootup sequence: "
        @ReadPort 2dh                   ;; AMI-BIOS, get boot sequence
        and     al, BOOTSEQ

        .IF     AL == BOOTSEQ
        @ShowStr "A: - C: (you should change this, if possible!)"

comment #
        @ReadPort 2dh
        xor     al, BOOTSEQ             ;; set it
        @WritePort 2dh
        @ShowStr " changed to C: - A:"  ;; this will require an cmos chksum
                                        ;; correction!
#
        .ELSE
        @ShowStr "C: - A:"
        .ENDIF
        @CRLF

        @ShowStr "AMI Flash BIOS installed: "
        mov     ax, 0E000h              ;; see AMI: Flash BIOS Reference
        int     16h

        .IF     !CARRY? && (AL == 0FAh)
        @ShowStr "Yes!"
        .ELSE
        @ShowStr "No!"
        .ENDIF
        @CRLF

        @GetVer
        xchg    ah, al

        .IF     AX < 500h
        @ShowStr "For ROM entry scanning you will need DOS 5.0 or better!"
        @CRLF
        .ELSE
        call    GetRomScanAdr           ;; print informations
        .ENDIF

        .EXIT   0                       ;; end program
;; ---- local functions ---------------------------------------------------

include hex.inc

;; ********************************************************************
;; DISPLAY_DECIMAL
;;
;; Displays "Value" on stdout
;;
;;
;; ********************************************************************


DisplayDec    proc uses ax bx cx dx ds, ;; .....Procedure
        Value   : Word;

        local   memTmp : Word

        mov     ax, Value

        mov     bl, 100                 ;; first 100
        idiv    bl
        mov     memTmp, ax
        add     al,'0'
        mov     bx, ax                  ;; AH == Remainder (Modulo)
        @ShowChar bl                    ;; print single char

        mov     bx, memTmp
        xor     ax, ax
        mov     al, bh
        mov     bl, 10                  ;; Remainder
        idiv    bl

        add     ax, "00"
        mov     bx, ax
        @ShowChar bl, bh, 32            ;; Print + Space

        Ret

DisplayDec    ENDP

;*****************************************************************************
; INT 21 U - DOS 5+ ROM - GET ROM SCAN START ADDRESS
;         AX = 6F00h
; Return: CF clear
;         AL = 00h
;         BX = current ROM scan starting segment
; SeeAlso: AH=6Dh,AX=6F01h,AX=6F02h
;
;*****************************************************************************
; INT 21 U - DOS 5+ ROM - FIND FIRST ROM PROGRAM
;         AH = 6Dh
;         DS:DX -> ASCIZ program name (may contain wildcrds)
; Return: CF clear if found
;             [DTA] = ROM search structure (see #0920)
;         CF set if not found
;             AX = error code
;                 0002h name not found in ROM
;                 0003h name contains colon or backslash
; Notes:  the '*' wildcard matches all remaining characters in a ROM program's
;         name; any following characters in the search mask are ignored up to
;         another asterisk, which must be matched by an asterisk in the
;         found program's name.
;         the search mask and program names may contain multiple periods
; SeeAlso: AH=1Ah,AH=4Eh,AH=6Eh,AX=6F00h,AX=6F02h
;
; Format of ROM search structure:
; Offset  Size    Description     (Table 0920)
;  00h 13 BYTEs   ASCIZ name of found ROM program
;  0Dh    DWORD   address at which to resume search (do not modify)
;  11h    var     ASCIZ search mask passed in (do not modify)
;
;*****************************************************************************
; INT 21 U - DOS 5+ ROM - FIND NEXT ROM PROGRAM
;         AH = 6Eh
;         [DTA] = result of previous FindFirst ROM (see AH=6Dh)
; Return: CF clear if found
;             [DTA] = updated ROM search structure (see #0920)
;         CF set if not found
;             AX = 0012h (no more matches)
; SeeAlso: AH=4Fh,AH=6Dh
;
;
;*****************************************************************************

GetRomScanAdr   proc near uses es bx dx ds,

;; [1]
        mov     ax, 06f00h      ;; get rom scan address
        int     21h
        .IF     !CARRY? && AL == 0
        @ShowStr "ROM scan address is: "
        invoke  HexWord, bx
        @ShowChar "h", 13, 10
        .ENDIF

;; [2]
        @SetDta OurDta
        @ShowStr "Find First ROM Program"
        mov     ah, 6dh
        mov     dx, offset RomNameMask
        int     21h

        .IF     !CARRY?
        @ShowChar ":", 13, 10
comment 
.REPEAT
        @GetDta
        @ShowStrZ  bx, es
        @ShowChar " "
        mov     AH, 6Eh         ; find next rom program
        int     21h
.UNTIL  CARRY? || AX == 0012h

        .ELSE
        @ShowStr " - Error!"
        .ENDIF
        @CRLF

        ret
GetRomScanAdr   endp


        .DATA
;; ---- Stack -------------------------------------------------------------
        .STACK                          ;; MASM Default Stack
;; ------------------------------------------------------------------------
        END
